(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define("vis-requestor", [], factory);
	else if(typeof exports === 'object')
		exports["vis-requestor"] = factory();
	else
		root["vis-requestor"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _util = __webpack_require__(1);
	
	var _util2 = _interopRequireDefault(_util);
	
	var _jsCookie = __webpack_require__(2);
	
	var _jsCookie2 = _interopRequireDefault(_jsCookie);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	var defaultOpt = {
	  onSessionExpired: function onSessionExpired() {},
	
	  ajaxOption: {
	    method: 'POST'
	  },
	
	  token: {
	    checkBeforeSend: true,
	    addToHeader: false,
	    cookieName: 'token',
	    headerName: 'X-Token'
	  },
	
	  resultCode: {
	    SESSION_EXPIRED: Symbol(),
	    SUCCEED: Symbol()
	  },
	
	  urlOption: {
	    host: '',
	    port: '',
	    base: ''
	  },
	
	  alert: function alert(msg) {
	    window.alert(msg);
	  },
	
	  failedMsg: ''
	};
	
	function requestor(jquery, globalOpt) {
	  var objOptions = ['ajaxOption', 'token', 'resultCode', 'urlOption'];
	  objOptions.forEach(function (option) {
	    globalOpt[option] = Object.assign({}, defaultOpt[option], globalOpt[option]);
	  });
	
	  globalOpt = Object.assign({}, defaultOpt, globalOpt);
	
	  globalOpt.ajaxOption.dataType = 'json';
	
	  var asyncAlert = function asyncAlert(msg) {
	    if (!msg) return;
	    setTimeout(function () {
	      globalOpt.alert(msg);
	    }, 0);
	  };
	
	  function getTokenFromCookie(tokenName) {
	    return _jsCookie2.default.get(tokenName);
	  }
	
	  function request(option) {
	    var tokenOption = globalOpt.token;
	    var token = getTokenFromCookie(tokenOption.cookieName);
	    var csrf_token = getTokenFromCookie(tokenOption.csrfName);
	
	    if (tokenOption && tokenOption.addToHeader && token) {
	      if (!option.headers) option.headers = {};
	      option.headers[tokenOption.headerName] = token;
	    }
	
	    if (tokenOption && tokenOption.addCsrfToHeader) {
	      if (!option.headers) option.headers = {};
	      option.headers[tokenOption.csrfName] = csrf_token;
	    }
	
	    var sessionExpiredResult = {
	      code: globalOpt.resultCode.SESSION_EXPIRED,
	      msg: 'Session expired!',
	      result: {}
	    };
	
	    if (tokenOption.checkBeforeSend && !token) {
	      globalOpt.onSessionExpired();
	      return new Promise(function (resolve, reject) {
	        reject(sessionExpiredResult);
	      });
	    }
	
	    if (option.data instanceof FormData) {
	      option.processData = false;
	      option.contentType = false;
	    }
	
	    return new Promise(function (resolve, reject) {
	      jquery.ajax(option).then(function (res, status, xhr) {
	        var code = res.code;
	
	        if (code === globalOpt.resultCode.SUCCEED) {
	          resolve(res);
	        } else {
	          // failed
	          if (code === globalOpt.resultCode.SESSION_EXPIRED) {
	            globalOpt.onSessionExpired();
	            reject(sessionExpiredResult);
	          } else {
	            reject(res);
	            asyncAlert(res.msg);
	          }
	        }
	      }, function (xhr) {
	        reject(xhr);
	        asyncAlert(globalOpt.failedMsg);
	      });
	    });
	  }
	
	  function requestJSON(apiOption, data) {
	    var currOption = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
	
	    var option = _util2.default.mergeAjaxOption(globalOpt.ajaxOption, apiOption, currOption, {
	      data: data
	    });
	
	    option.url = _util2.default.normalizeUrl(jquery, option.url, option.query, globalOpt.urlOption);
	    delete option.query;
	
	    var contentType = option.contentType;
	    var contentTypeIsJson = contentType && contentType.includes('application/json');
	    var processData = !contentTypeIsJson && !(option.processData === false);
	    if (processData && jquery.isPlainObject(option.data)) {
	      _util2.default.stringifyData(option.data);
	    }
	
	    if (contentTypeIsJson && typeof option.data !== 'string' && !(option.data instanceof FormData)) {
	      option.data = JSON.stringify(option.data);
	    }
	
	    return request(option);
	  }
	
	  function requestAPI() {
	    return requestJSON.apply(undefined, arguments).then(function (res) {
	      return res.result;
	    });
	  }
	  function requestJanusAPI() {
	    return requestJSON.apply(undefined, arguments).then(function (res) {
	      return res.data;
	    });
	  }
	
	  return {
	    request: request,
	    requestAPI: requestAPI,
	    requestJanusAPI: requestJanusAPI,
	    requestJSON: requestJSON };
	}
	
	exports.default = requestor;

/***/ }),
/* 1 */
/***/ (function(module, exports) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };
	
	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };
	
	var HTTP_PROTOCOL = /^http[s]?:\/\//;
	
	function normalizeUrl(jquery, url, query, option) {
	  var fullUrl = url;
	  if (!HTTP_PROTOCOL.test(url)) {
	    fullUrl = option.host || '';
	
	    if (option.port) {
	      fullUrl += option.port ? ':' + option.port : '';
	    }
	
	    if (option.base) {
	      fullUrl += option.base;
	    }
	
	    if (url) fullUrl += url;
	  }
	
	  if (query && Object.keys(query).length) {
	    var connChar = fullUrl.includes('?') ? '&' : '?';
	    fullUrl += connChar + jquery.param(query);
	  }
	
	  return fullUrl;
	}
	
	function mergeAjaxOption() {
	  for (var _len = arguments.length, options = Array(_len), _key = 0; _key < _len; _key++) {
	    options[_key] = arguments[_key];
	  }
	
	  var option1 = options.shift() || {};
	  var option2 = options.shift() || {};
	
	  var query = _extends({}, option1.query, option2.query);
	
	  var data = option2.data || option1.data;
	  var data1IsObj = option1.data && _typeof(option1.data) === 'object';
	  var data2IsObj = option2.data && _typeof(option2.data) === 'object';
	  var data1IsFormData = option1.data instanceof FormData;
	  var data2IsFormData = option2.data instanceof FormData;
	  if (!data1IsFormData && !data2IsFormData && data1IsObj && data2IsObj) {
	    data = _extends({}, option1.data, option2.data);
	  }
	
	  var headers = _extends({}, option1.headers, option2.headers);
	
	  var mergedResult = _extends({}, option1, option2, {
	    query: query,
	    data: data,
	    headers: headers
	  });
	
	  if (options.length) {
	    options.unshift(mergedResult);
	    return mergeAjaxOption.apply(undefined, options);
	  } else {
	    return mergedResult;
	  }
	}
	
	function stringifyData(data) {
	  for (var p in data) {
	    var dp = data[p];
	    if ((typeof dp === 'undefined' ? 'undefined' : _typeof(dp)) === 'object' && dp !== null) {
	      data[p] = JSON.stringify(dp);
	    }
	  }
	}
	
	exports.default = {
	  normalizeUrl: normalizeUrl,
	  mergeAjaxOption: mergeAjaxOption,
	  stringifyData: stringifyData
	};

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

	var __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_RESULT__;/*!
	 * JavaScript Cookie v2.2.0
	 * https://github.com/js-cookie/js-cookie
	 *
	 * Copyright 2006, 2015 Klaus Hartl & Fagner Brack
	 * Released under the MIT license
	 */
	;(function (factory) {
		var registeredInModuleLoader = false;
		if (true) {
			!(__WEBPACK_AMD_DEFINE_FACTORY__ = (factory), __WEBPACK_AMD_DEFINE_RESULT__ = (typeof __WEBPACK_AMD_DEFINE_FACTORY__ === 'function' ? (__WEBPACK_AMD_DEFINE_FACTORY__.call(exports, __webpack_require__, exports, module)) : __WEBPACK_AMD_DEFINE_FACTORY__), __WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
			registeredInModuleLoader = true;
		}
		if (true) {
			module.exports = factory();
			registeredInModuleLoader = true;
		}
		if (!registeredInModuleLoader) {
			var OldCookies = window.Cookies;
			var api = window.Cookies = factory();
			api.noConflict = function () {
				window.Cookies = OldCookies;
				return api;
			};
		}
	}(function () {
		function extend () {
			var i = 0;
			var result = {};
			for (; i < arguments.length; i++) {
				var attributes = arguments[ i ];
				for (var key in attributes) {
					result[key] = attributes[key];
				}
			}
			return result;
		}
	
		function init (converter) {
			function api (key, value, attributes) {
				var result;
				if (typeof document === 'undefined') {
					return;
				}
	
				// Write
	
				if (arguments.length > 1) {
					attributes = extend({
						path: '/'
					}, api.defaults, attributes);
	
					if (typeof attributes.expires === 'number') {
						var expires = new Date();
						expires.setMilliseconds(expires.getMilliseconds() + attributes.expires * 864e+5);
						attributes.expires = expires;
					}
	
					// We're using "expires" because "max-age" is not supported by IE
					attributes.expires = attributes.expires ? attributes.expires.toUTCString() : '';
	
					try {
						result = JSON.stringify(value);
						if (/^[\{\[]/.test(result)) {
							value = result;
						}
					} catch (e) {}
	
					if (!converter.write) {
						value = encodeURIComponent(String(value))
							.replace(/%(23|24|26|2B|3A|3C|3E|3D|2F|3F|40|5B|5D|5E|60|7B|7D|7C)/g, decodeURIComponent);
					} else {
						value = converter.write(value, key);
					}
	
					key = encodeURIComponent(String(key));
					key = key.replace(/%(23|24|26|2B|5E|60|7C)/g, decodeURIComponent);
					key = key.replace(/[\(\)]/g, escape);
	
					var stringifiedAttributes = '';
	
					for (var attributeName in attributes) {
						if (!attributes[attributeName]) {
							continue;
						}
						stringifiedAttributes += '; ' + attributeName;
						if (attributes[attributeName] === true) {
							continue;
						}
						stringifiedAttributes += '=' + attributes[attributeName];
					}
					return (document.cookie = key + '=' + value + stringifiedAttributes);
				}
	
				// Read
	
				if (!key) {
					result = {};
				}
	
				// To prevent the for loop in the first place assign an empty array
				// in case there are no cookies at all. Also prevents odd result when
				// calling "get()"
				var cookies = document.cookie ? document.cookie.split('; ') : [];
				var rdecode = /(%[0-9A-Z]{2})+/g;
				var i = 0;
	
				for (; i < cookies.length; i++) {
					var parts = cookies[i].split('=');
					var cookie = parts.slice(1).join('=');
	
					if (!this.json && cookie.charAt(0) === '"') {
						cookie = cookie.slice(1, -1);
					}
	
					try {
						var name = parts[0].replace(rdecode, decodeURIComponent);
						cookie = converter.read ?
							converter.read(cookie, name) : converter(cookie, name) ||
							cookie.replace(rdecode, decodeURIComponent);
	
						if (this.json) {
							try {
								cookie = JSON.parse(cookie);
							} catch (e) {}
						}
	
						if (key === name) {
							result = cookie;
							break;
						}
	
						if (!key) {
							result[name] = cookie;
						}
					} catch (e) {}
				}
	
				return result;
			}
	
			api.set = api;
			api.get = function (key) {
				return api.call(api, key);
			};
			api.getJSON = function () {
				return api.apply({
					json: true
				}, [].slice.call(arguments));
			};
			api.defaults = {};
	
			api.remove = function (key, attributes) {
				api(key, '', extend(attributes, {
					expires: -1
				}));
			};
	
			api.withConverter = init;
	
			return api;
		}
	
		return init(function () {});
	}));


/***/ })
/******/ ])
});
;
//# sourceMappingURL=vis-requestor.js.map